include \masm32\include\masm32rt.inc

FSIGN MACRO rval
  ifb <rval>
	fst real8 ptr [esp-8]
	test byte ptr [esp-8+7], 80h		;; usage for sign of ST0: .if FSIGN()
  else
	test byte ptr [rval-1+sizeof rval], 80h	;; usage:  .if FSIGN(MyRealVar)
  endif
  EXITM <Sign?>
ENDM

.code
r8pos	REAL8	1.12345
r8minus	REAL8	-1.12345
r8zeroA	REAL8	0.0
r8zeroB	REAL8	-0.0
r4pos	REAL4	1.12345
r4minus	REAL4	-1.12345
r4zeroA	REAL4	0.0
r4zeroB	REAL4	-0.0
r10pos	REAL10	1.12345
r10minus	REAL10	-1.12345
r10zeroA	REAL10	1.0e-308
r10zeroB	REAL10	-1.0e-308

start:
	print "---- Test local vars:", 13, 10, 10
	call TestLoc
	print "---- Test ST(0):", 13, 10, 10
	ffree st(7)
	fld r10pos
	.if FSIGN()
		print "r10pos   is negative", 13, 10
	.else
		print "r10pos   is positive", 13, 10
	.endif
	fincstp
	ffree st(7)
	fld r10minus
	.if FSIGN()
		print "r10minus is negative", 13, 10
	.else
		print "r10minus is positive", 13, 10
	.endif
	fincstp

	ffree st(7)
	fld r10zeroA
	.if FSIGN()
		print "r10zeroA is negative", 13, 10
	.else
		print "r10zeroA is positive", 13, 10
	.endif
	fincstp

	ffree st(7)
	fld r10zeroB
	.if FSIGN()
		print "r10zeroB is negative", 13, 10, 10
	.else
		print "r10zeroB is positive", 13, 10, 10
	.endif
	fincstp

	print "---- Test global real variables:", 13, 10, 10
	
	.if FSIGN(r4pos)
		print "r4pos   is negative", 13, 10
	.else
		print "r4pos   is positive", 13, 10
	.endif
	.if FSIGN(r4minus)
		print "r4minus is negative", 13, 10
	.else
		print "r4minus is positive", 13, 10
	.endif
	.if FSIGN(r4zeroA)
		print "r4zeroA is negative", 13, 10
	.else
		print "r4zeroA is positive", 13, 10
	.endif
	.if FSIGN(r4zeroB)
		print "r4zeroB is negative", 13, 10
	.else
		print "r4zeroB is positive", 13, 10
	.endif

	print chr$(13, 10)
	.if FSIGN(r8pos)
		print "r8pos   is negative", 13, 10
	.else
		print "r8pos   is positive", 13, 10
	.endif
	.if FSIGN(r8minus)
		print "r8minus is negative", 13, 10
	.else
		print "r8minus is positive", 13, 10
	.endif
	.if FSIGN(r8zeroA)
		print "r8zeroA is negative", 13, 10
	.else
		print "r8zeroA is positive", 13, 10
	.endif
	.if FSIGN(r8zeroB)
		print "r8zeroB is negative", 13, 10
	.else
		print "r8zeroB is positive", 13, 10
	.endif

	print chr$(13, 10)
	.if FSIGN(r10pos)
		print "r10pos   is negative", 13, 10
	.else
		print "r10pos   is positive", 13, 10
	.endif
	.if FSIGN(r10minus)
		print "r10minus is negative", 13, 10
	.else
		print "r10minus is positive", 13, 10
	.endif
	.if FSIGN(r10zeroA)
		print "r10zeroA is negative", 13, 10
	.else
		print "r10zeroA is positive", 13, 10
	.endif
	.if FSIGN(r10zeroB)
		print "r10zeroB is negative", 13, 10
	.else
		print "r10zeroB is positive", 13, 10
	.endif
	
	getkey
	exit

TestLoc proc
LOCAL Loc4pos:REAL4, Loc4minus:REAL4, Loc4zeroA:REAL4, Loc4zeroB:REAL4
LOCAL Loc8pos:REAL8, Loc8minus:REAL8, Loc8zeroA:REAL8, Loc8zeroB:REAL8
    FOR rv, <Loc4pos, Loc4minus, Loc4zeroA, Loc4zeroB,,Loc8pos, Loc8minus, Loc8zeroA, Loc8zeroB,,>
    	ifb <rv>
    		print chr$(13,10)
    	else
	ffree st(7)
	tmp1$ SUBSTR <rv>, 4
	tmp$ CATSTR <fld r>, tmp1$
	% tmp$
	fst rv
	fincstp
	.if FSIGN(rv)
		tmp$ CATSTR <print "Loc>, tmp1$, < is negative", 13, 10>
		tmp$
	.else
		tmp$ CATSTR <print "Loc>, tmp1$, < is positive", 13, 10>
		tmp$
	.endif
	endif
  ENDM
  ret
TestLoc endp

end start
OPT_Tmp2Asm	1
